package madkit.strobekit.idialogue;

import madkit.kernel.AgentAddress;
import madkit.strobekit.CognitiveEnv;
import madkit.strobekit.strobedemo.StrobeDemoAgent;

abstract class Dialogue extends Thread{

//	------------------	
//	Attributes
//	------------------
	
	// STROBA - The agent who run the dialogue
	StrobeDemoAgent stroba;
	
	// ACQADDRESS- The acquaintance stroba have a dialogue with
	AgentAddress acqAddress;
	
	// ACQCOENV - The CognitiveEnv of acqAddress
	CognitiveEnv acqCoEnv;
	
	// ACQSTEPFCN - What to do with the messages from AcqAddress
	StepFcnInterface acqStepFcn;
	
	// ACQRESULTFCN - Result of the dialogue
	ResultFcnInterface acqResultFcn;
		
	// DONE - Boolean to stop or not the dialogue
	boolean done = false;
	
	// RESULT - The result of the dialogue
	Object result;
	
//	------------------	
//  Methods
//	------------------	
	
    //	------------------	
    //  Constructors
    //	------------------	
	
    Dialogue(StrobeDemoAgent a, AgentAddress ad, StepFcnInterface sfcn, ResultFcnInterface rfcn){
    	stroba = a;
    	acqAddress = ad;
    	acqCoEnv = (CognitiveEnv)stroba.getLocalEnvs().get(ad);
    	acqStepFcn = sfcn;
    	acqResultFcn = rfcn;
    }
        	
	public void run(){
		// TBD
		while(!done){
			done = acqStepFcn.stepFcn(acqCoEnv.getInputStream(), acqCoEnv, acqCoEnv.getOutputStream());
		}
		acqResultFcn.resultFcn(acqCoEnv);
	}
}