/*
 BindsWindow.java
 Clement Jonquet - PhD student in computer science - LIRMM - July 2005
*/

package madkit.strobekit.strobedemo;

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.table.*;

import madkit.kernel.AgentAddress;
import madkit.strobekit.CognitiveEnv;

import gnu.mapping.SimpleEnvironment;
import gnu.mapping.LocationEnumeration;
import gnu.mapping.NamedLocation;;


public class BindsWindow extends JFrame implements ActionListener{

//	 --- Attributes ---

    StrobeDemoAgent stroba;
    
    JPanel mainPanel;
    JLabel agentBindLabel;
	JTextArea bindDisplayTA;
	JScrollPane bindDisplayTASP;
	JComboBox bindChoiceCB;
	JButton displayBindButton;
	SimpleEnvironment[] simpleEnvTab;
	JTable table;

	BindsWindow(StrobeDemoAgent a){
		
		stroba = a;
		setTitle("Agent  "+stroba.getName()+"  binds");
		setSize(500,500);
		setResizable(false);
		
		mainPanel = new JPanel();
		getContentPane().add(mainPanel);
		
		// Agent label
		agentBindLabel = new JLabel();
		agentBindLabel.setText("Agent:");
		agentBindLabel.setPreferredSize(new Dimension(80, 24));
		mainPanel.add(agentBindLabel);
		
		// Bind Choice ComboBox
		bindChoiceCB = new JComboBox();
		bindChoiceCB.setComponentOrientation(ComponentOrientation.LEFT_TO_RIGHT);
		bindChoiceCB.setPreferredSize(new Dimension(150, 24));
		bindChoiceCB.addActionListener(this);
		ComboBoxModel newAgentListModel = new DefaultComboBoxModel(stroba.acquaintanceAndINames());
		bindChoiceCB.setModel(newAgentListModel);
		mainPanel.add(bindChoiceCB);
		
		// Display bind button
		displayBindButton = new JButton("Display"); 
		displayBindButton.addActionListener(this);
		mainPanel.add(displayBindButton);
		
		table = new JTable();
		
		bindDisplayTASP = new JScrollPane(table);
		mainPanel.add(bindDisplayTASP);
		
	} 
	 
	public void actionPerformed(ActionEvent e){
		String s = e.getActionCommand();
    	if(s.equals("Display")){
    		AgentAddress agent = stroba.acquaintanceAndIAddresses()[bindChoiceCB.getSelectedIndex()];	
    		CognitiveEnv localEnv;
    		if(agent==stroba.getAddress()){
    			localEnv = stroba.getGlobalEnv();
    		}
    		else{localEnv = (CognitiveEnv)stroba.getLocalEnvs().get(agent);}
    		displayBind(localEnv.getBind());
    	}
	}

	void displayBind(SimpleEnvironment env){
		if (env != null){
			HashMap binds = new HashMap();
			for(LocationEnumeration b = env.enumerateLocations(); b.hasMoreElements();){		
				NamedLocation s = (NamedLocation)b.nextLocation();
				String key=s.getKeySymbol().toString();
				Object val=s.get();
				if (!binds.containsKey(key)){
					binds.put(key,val);
				}
			}
				
			final Object rowData[][] = new Object[binds.size()][2];
			
			Set lesEntrees = binds.entrySet();
			Iterator it = lesEntrees.iterator();
			int i = 0;
			while (it.hasNext()){
				Map.Entry e = (Map.Entry) it.next ();	
				rowData[i][0] = e.getKey();
				rowData[i][1] = e.getValue();
				i++;
			}
			
			final String columnNames[] = new String[2];
			columnNames[0]="Variable";
			columnNames[1]="Value";
			
			AbstractTableModel modele = new AbstractTableModel()
			{
	 			public String getColumnName(int col) {return columnNames[col].toString();  }
	 			public int getRowCount() { return rowData.length; }
	 			public int getColumnCount() { return columnNames.length; }
	 			public Object getValueAt(int row, int col) {return rowData[row][col];    }
	 			public boolean isCellEditable(int row, int col) { return false; }
	 			public void setValueAt(Object value, int row, int col) 
				{
	 				rowData[row][col] = value;
	 				fireTableCellUpdated(row, col);
	    		}
			};
			
			table.setModel(modele);
			
			/*
			 for (SymbolEnumeration b = env.enumerateAllSymbols() ; b.hasMoreElements();)
			 {
					Symbol s=b.nextSymbol();
					boolean erreur=false;
					try
					{
					s.getValue();
					}
					catch(java.lang.Throwable e)
					{
						erreur=true;
						}
						if (!erreur)
						{
						afficher(s.getKey().toString()+"  ->  "+s.getValue().toString());
						nb++;
						}
						}
			*/
				/*
				 for (BindingEnumeration b = env.enumerateAllBindings() ; b.hasMoreElements();)
				{
				Binding i=b.nextBinding();
				boolean erreur=false;
				Object val=null;										
				
				try
				{
				val=i.getValue();
				}
				catch(java.lang.Throwable e)
					{
					erreur=true;
					}
					if (!erreur)
					{
					afficher(i.getKey().toString()+"  ->  "+val.toString());
					nb++;
					}
				//System.out.println(i);
				 }
				 */
					}
			//afficher("Total : "+nb+" binds");
		}

	/*private void afficher(String s)	{
		bindDisplayTA.setEditable(true);
		bindDisplayTA.append(s+"\n");
		bindDisplayTA.setEditable(false);
		bindDisplayTA.setCaretPosition(bindDisplayTA.getDocument().getLength());
	}*/	
}

