package madkit.strobekit.strobedemo;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

import madkit.kernel.AgentAddress;

public class ChoiceEnvWindow extends JFrame implements ActionListener{
	
	StrobeDemoAgent stroba;
	AgentAddress newAcq;
	
	JPanel mainPanel, titlePanel, copyPanel, sharingPanel;
	JLabel titleLabel;
	JComboBox envChoiceCopyCB, envChoiceShareCB;
	JButton copyButton, sharingButton;
	
	AgentAddress choosenAgent = null;
	boolean sharing = false;
	
	ChoiceEnvWindow(StrobeDemoAgent a, AgentAddress ad){
		
		stroba = a;
		newAcq = ad;
		
		setTitle("Cognitive Environment creation");
		setSize(550,200);
		//setResizable(false);
		
		mainPanel = new JPanel();
		mainPanel.setLayout(new BoxLayout(mainPanel, BoxLayout.PAGE_AXIS));
		getContentPane().add(mainPanel);
		
		// Title configuration
		titlePanel = new JPanel();
		titleLabel = new JLabel();
		titleLabel.setText("Choose "+stroba.getName()+"'s Cognitive Environment dedicated to "+newAcq.getName());
		titlePanel.add(titleLabel);
		mainPanel.add(titlePanel);
		
		// Copy panel configuration
		copyPanel = new JPanel(new FlowLayout(FlowLayout.LEFT));
		copyPanel.setBorder(BorderFactory.createCompoundBorder(
	            BorderFactory.createTitledBorder("Copying: "), 
	            BorderFactory.createEmptyBorder(2,2,2,2)));
		
		envChoiceCopyCB = new JComboBox();
		envChoiceCopyCB.setComponentOrientation(ComponentOrientation.LEFT_TO_RIGHT);
		envChoiceCopyCB.setPreferredSize(new Dimension(150, 24));
		envChoiceCopyCB.addActionListener(this);
		ComboBoxModel newAgentListModel = new DefaultComboBoxModel(stroba.acquaintanceAndINames());
		envChoiceCopyCB.setModel(newAgentListModel);
		copyPanel.add(envChoiceCopyCB);
		
		copyButton = new JButton("Copy");
		copyButton.addActionListener(this);
		copyPanel.add(copyButton);
		
		mainPanel.add(copyPanel);
		
		// Sharing panel configuration
		sharingPanel=new JPanel(new FlowLayout(FlowLayout.LEFT));
		sharingPanel.setBorder(BorderFactory.createCompoundBorder(
	            BorderFactory.createTitledBorder("Sharing: "), 
	            BorderFactory.createEmptyBorder(2,2,2,2)));
		
		envChoiceShareCB = new JComboBox();
		envChoiceShareCB.setComponentOrientation(ComponentOrientation.LEFT_TO_RIGHT);
		envChoiceShareCB.setPreferredSize(new Dimension(150, 24));
		envChoiceShareCB.addActionListener(this);
		ComboBoxModel newAgentListModel2 = new DefaultComboBoxModel(stroba.acquaintanceNames());
		envChoiceShareCB.setModel(newAgentListModel2);
		sharingPanel.add(envChoiceShareCB);
		
		sharingButton=new JButton("Share");
		sharingButton.addActionListener(this);	
		sharingPanel.add(sharingButton);
		
		if (stroba.acquaintanceNames().length == 0){
			envChoiceShareCB.setEnabled(false);
			sharingButton.setEnabled(false);
		}	
		mainPanel.add(sharingPanel);
	}
	
	public void actionPerformed(ActionEvent e){
		String s = e.getActionCommand();
		
		if (s.equals("Copy")){
			choosenAgent = stroba.acquaintanceAndIAddresses()[envChoiceCopyCB.getSelectedIndex()];
			dispose();
		}
		else if (s.equals("Share")){
			choosenAgent = stroba.acquaintanceAddresses()[envChoiceShareCB.getSelectedIndex()];
			sharing = true;
			dispose();
		}		
	}
	
	/*
	public void creerCombos()
	{
		HashMap envs=agent.envs;
		
		SimpleEnvironment[] ListeEnv=new SimpleEnvironment[envs.size()];
		String[] SListe=new String[envs.size()];
		AgentAddress[] ListeAd=new AgentAddress[envs.size()];
		
		Set lesEntrees = envs.entrySet ();
		Iterator it = lesEntrees.iterator ();
		int i=0;
		int envsInit=0;
		while (it.hasNext ())
	    {
			Map.Entry e = (Map.Entry) it.next ();
			AgentAddress ad=(AgentAddress)e.getKey();
			Env env=(Env)e.getValue();
			
			if (env.isInit())	envsInit++;
			SListe[i]=ad.getName();
			ListeEnv[i]=env.getEnvScm();
			ListeAd[i]=(AgentAddress)e.getKey();
			i++;
		}
		
		//on filtre les environnements
		String[] SListe1=new String[envsInit];
		String[] SListe2=new String[envsInit-1];

		ListeEnv1=new SimpleEnvironment[envsInit];
		ListeEnv2=new SimpleEnvironment[envsInit-1];
		
		i=0;//index pour listes1
		int k=0;//index pour listes2
		for (int j=0;j<envs.size();j++)
		{
			if (ListeEnv[j]!=null)
			{
				if (ListeAd[j]!=agent.getAddress())
				{
					SListe2[k]=ListeAd[j].toString();
					SListe1[i]=ListeAd[j].toString();
					ListeEnv2[k]=ListeEnv[j];
					ListeEnv1[i]=ListeEnv[j];
					i++;
					k++;
				}
				else
				{
					SListe1[i]="Env Global";
					ListeEnv1[i]=ListeEnv[j];
					i++;
				}
			}
		}
	
		//remplissage des combos
		envChoiceCopyCB=new JComboBox(SListe1);
		envChoiceShareCB=new JComboBox(SListe2);
		if (envsInit<2)
		{
			envChoiceShareCB.setEnabled(false);
			sharingButton.setEnabled(false);
		}			
	}
	*/
}
