/*
* StrobeDemoAgent.java
* Clement Jonquet - PhD student in computer science - LIRMM - August 2005
*/

package madkit.strobekit.strobedemo;

import madkit.strobekit.*;
import madkit.kernel.AgentAddress;
import madkit.kernel.JTextAreaWriter;

import gnu.mapping.OutPort;

import java.io.Writer;


public class StrobeDemoAgent extends StrobeAbstractAgent{

    // GUI - Graphic interface instance
    StrobeDemoAgentGUI gui;
    
    // StrobeDemoWriter - The agent output redirection
    Writer StrobeDemoWriter;
    
	//	------------------	
	//	MadKit methods
	//	------------------	
    
    public StrobeDemoAgent(){
    	group = "StrobeDemoGroup";
    	role = "StrobeDemoRole";
   }
    
    public void initGUI(){
        gui = new StrobeDemoAgentGUI(this);
        setGUIObject(gui);
    }
    
    public void strobeActivate(){
    	
    	// OutputWriter redirection
    	StrobeDemoWriter = new JTextAreaWriter(gui.outputTA);
    	setOutputWriter(StrobeDemoWriter);
    	 
    	// Group/Role managenemt
    	createOrJoinGroup(getStrobeAgentGroup());
    	requestRole("strobe", getStrobeAgentGroup(), getStrobeAgentRole(), null);
    	println("My role: "+getStrobeAgentRole());
    	println("_______________________________");
	    
    	
    	// GUI update
    	gui.strobeAgentGUIUpdate();
     }

    public void strobeLive(){
    	while(true){
    	    exitImmediatlyOnKill ();	//pour permettre de fermer l'agent 
    		
    		// READ - Receive and dispatch messages in corresponding input streams
    		eval(read());
    		print();
    		//mental.scheduler(envs);
    		//envoiTousMessages();
    	}
	}

	public void strobeEnd(){
		
		println("@+");
	}

	public void addAcquaintance(AgentAddress a){
    	//CognitiveEnv localEnv;
    	//localEnv = new CognitiveEnv(this, a);
    	//localEnvs.put(a, localEnv);
    	
    	ChoiceEnvWindow envWin = new ChoiceEnvWindow(this, a);
    	envWin.setVisible(true);
    	
    	while(envWin.choosenAgent == null){
    		System.out.println("Please, choose to copy or share an existing Cognitive Environment...");
    		pause(3000);
    	}
    	if(envWin.sharing){
    		addAcquaintanceBySharingLocalEnv(a, envWin.choosenAgent);
    	}
    	else{
    		if (envWin.choosenAgent==getAddress()){
    			addAcquaintanceByCopyingGlobalEnv(a);
        	}
    		addAcquaintanceByCopyingLocalEnv(a, envWin.choosenAgent);
    	}
    }
	public void analyzeAnswer(String res){
		println("Answer processing...");
	}
	
	
	//	----------------------	
	//	Miscellaneous methods
	//	----------------------
    
	  	  
		
}