package madkit.strobekit.strobedemo;

import madkit.kernel.AgentAddress;
import madkit.strobekit.StrobeMsg;

import java.awt.*;
import javax.swing.*;

import java.awt.event.*;

public class StrobeDemoAgentGUI extends JPanel implements ActionListener{
    
//	 --- Attributes ---

    StrobeDemoAgent stroba;
    
    JPanel agentInfosPanel, msgAndMiscPanel, msgEditionPanel, msgReceiverPanel, msgPerfoPanel, msgContentPanel, miscPanel, outpoutPanel;
    JLabel agentInfosLabel, msgReceiverLabel, msgPerfoLabel, msgContentLabel;
	JComboBox msgReceiverCB = null, msgPerfoCB=null;
	JTextField msgEditionTF;
	JButton msgUpdateReceiverListButton, msgSendButton, bindsButton, clearOutputButton;
	JTextArea outputTA;
    JScrollPane outputTASP;
	
    // La liste des perfo doit etre stock dans l'coenv dedie et le combo construit dynamiquement en fonction de cela
    String[] perfoList = {"order", "assertion", "request"};
    
    static String AGENTINFOS;
    
    
//  --- Methods ---
	
    //  --- Constructors ---
    
	public StrobeDemoAgentGUI(StrobeDemoAgent a){
		
		stroba = a;
		setSize(300,200);
		setLayout(new BoxLayout(this, BoxLayout.PAGE_AXIS));
        setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
        AGENTINFOS = "<html><b>Name</b>: "+stroba.getName()
        			+"<br><b>AgentAddress</b>: "+stroba.getAddress().toString()
					+"<br><b>Group</b>: "+stroba.getStrobeAgentGroup()
					+"<br><b>Role</b>: "+stroba.getStrobeAgentRole()+"</html>";
		
		// Agent Infos Panel
		agentInfosPanel = new JPanel();
		agentInfosLabel = new JLabel();
    	agentInfosLabel.setText(AGENTINFOS);
    	agentInfosPanel.add(agentInfosLabel);
		agentInfosPanel.setBorder(BorderFactory.createCompoundBorder(
	            BorderFactory.createTitledBorder("Agent:"), 
	            BorderFactory.createEmptyBorder(2,2,2,2)));
		add(agentInfosPanel);
		
    	// Message edition panel
    	msgEditionPanel = new JPanel(new BorderLayout());
    	
    	// Message receiver edition panel
    	msgReceiverPanel = new JPanel(new FlowLayout(FlowLayout.LEFT));
		
		msgReceiverLabel = new JLabel();
		msgReceiverLabel.setText("Receiver:");
		msgReceiverLabel.setPreferredSize(new Dimension(80, 24));
		msgReceiverPanel.add(msgReceiverLabel);
		msgReceiverCB = new JComboBox();
		msgReceiverCB.setComponentOrientation(ComponentOrientation.LEFT_TO_RIGHT);
		msgReceiverCB.setPreferredSize(new Dimension(150, 24));
		msgReceiverCB.addActionListener(this);
		msgReceiverPanel.add(msgReceiverCB);
		msgUpdateReceiverListButton = new JButton("Refresh"); 
		msgReceiverPanel.add(msgUpdateReceiverListButton);
		msgUpdateReceiverListButton.addActionListener(this);
		msgEditionPanel.add(msgReceiverPanel ,BorderLayout.NORTH);

		// Message performative edition panel
		msgPerfoPanel = new JPanel(new FlowLayout(FlowLayout.LEFT));
				
		msgPerfoLabel = new JLabel();
		msgPerfoLabel.setText("Performative:");
		msgPerfoLabel.setPreferredSize(new Dimension(80, 24));
		msgPerfoPanel.add(msgPerfoLabel);
		msgPerfoCB = new JComboBox();
		msgPerfoCB.setComponentOrientation(ComponentOrientation.LEFT_TO_RIGHT);
		msgPerfoCB.setPreferredSize(new Dimension(150, 24));
		ComboBoxModel newPerfoList = new DefaultComboBoxModel(perfoList);
		msgPerfoCB.setModel(newPerfoList);
		msgPerfoPanel.add(msgPerfoCB);
		msgEditionPanel.add(msgPerfoPanel, BorderLayout.CENTER);
		
		// Message content edition panel
		msgContentPanel = new JPanel(new FlowLayout(FlowLayout.LEFT));
		
		msgContentLabel = new JLabel();
		msgContentLabel.setText("Content:");
    	msgContentLabel.setPreferredSize(new Dimension(80, 24));
    	msgContentPanel.add(msgContentLabel);
		msgEditionTF = new JTextField(16);
    	msgEditionTF.setPreferredSize(new Dimension(150, 24));
    	/*
    	msgEditionTF.addKeyListener(new KeyAdapter(){
    		public void keyReleased(KeyEvent e){
    			if(e.getKeyChar() == KeyEvent.VK_ENTER){
    				AgentAddress dest = receiverAgentAddressList[msgReceiverCB.getSelectedIndex()];
    				String perfo = perfoList[msgPerfoCB.getSelectedIndex()];
    				StrobeMsg msg = new StrobeMsg(stroba.getAddress(), dest, perfo, msgEditionTF.getText());
    				stroba.sendOneMessage(msg);
    			}
		}});
		*/
    	msgContentPanel.add(msgEditionTF);
		msgSendButton = new JButton("Send");
		msgContentPanel.add(msgSendButton);
		msgSendButton.addActionListener(this);
		msgEditionPanel.add(msgContentPanel, BorderLayout.SOUTH);
		msgEditionPanel.setBorder(BorderFactory.createCompoundBorder(
	            BorderFactory.createTitledBorder("Action:"), 
	            BorderFactory.createEmptyBorder(5,5,5,5)));
		
		// Misc panel
		miscPanel = new JPanel(new BorderLayout());
		
		bindsButton = new JButton("Binds");
		bindsButton.addActionListener(this);
		miscPanel.add(bindsButton, BorderLayout.NORTH);
		clearOutputButton = new JButton("Clear Output");
		clearOutputButton.addActionListener(this);	
		miscPanel.add(clearOutputButton, BorderLayout.SOUTH);
		miscPanel.setBorder(BorderFactory.createCompoundBorder(
	            BorderFactory.createTitledBorder("Misc:"), 
	            BorderFactory.createEmptyBorder(5,5,5,5)));
		
		// Msg and Misc panel
		msgAndMiscPanel = new JPanel(new FlowLayout(FlowLayout.CENTER));
		msgAndMiscPanel.add(msgEditionPanel, BorderLayout.EAST);
		msgAndMiscPanel.add(miscPanel, BorderLayout.WEST);
		add(msgAndMiscPanel);
		
		// Output panel
		outpoutPanel = new JPanel();
		outputTA = new JTextArea(15,70);
		outputTA.setEditable(false);
		outputTASP = new JScrollPane(outputTA);
		outpoutPanel.add(outputTASP);
		//outpoutPanel.add(outputTA);			
		outpoutPanel.setBorder(BorderFactory.createCompoundBorder(
	            BorderFactory.createTitledBorder("Outpout:"), 
	            BorderFactory.createEmptyBorder(5,5,5,5)));
		add(outpoutPanel);
    }

	//  --- Methods ---
    
	public void strobeAgentGUIUpdate(){
		agentInfosLabel.setText(AGENTINFOS);
    	updateReceiverAgentStringList();
	}
	
	private void updateReceiverAgentStringList(){
		ComboBoxModel newAgentListModel = new DefaultComboBoxModel(stroba.viewedAgentName());
		msgReceiverCB.setModel(newAgentListModel);
    }
	
    public void actionPerformed(ActionEvent e){
    	String s = e.getActionCommand();
    	if(s.equals("Send")){
    			AgentAddress receiver = stroba.viewedAgentAddress()[msgReceiverCB.getSelectedIndex()];	
    			String perfo = (String)msgPerfoCB.getSelectedItem();
    			String content = msgEditionTF.getText();
    			StrobeMsg msg = new StrobeMsg(perfo, content);
    			stroba.sendMessageAndPrint(receiver, msg);
    	}
    	else if(s.equals("Refresh")){
    		updateReceiverAgentStringList();
    			
    	}	
    	else if(s.equals("Clear Output")){
    			outputTA.replaceRange("",0,outputTA.getDocument().getLength());
    	}
    	else if(s.equals("Binds")){
    			BindsWindow bindsWin = new BindsWindow(stroba);
    			bindsWin.setVisible(true);
    	}
    	//else updatePerfoList();	    			
    }
    
    public void updatePerfoList(){
		AgentAddress receiver = stroba.viewedAgentAddress()[msgReceiverCB.getSelectedIndex()];
		/*
		CognitiveEnv e = (CognitiveEnv)stroba.coEnvs.get(dest);
		if(e==null || !e.isInit()){
			//par defaut on met les perfo de l'env global
			e = (CognitiveEnv)stroba.coEnvs.get(stroba.getAddress());
		}
		perfoList = e.listerPerformatifs();
		ComboBoxModel newPerfoList = new DefaultComboBoxModel(perfoList);
		msgPerfoCB.setModel(newPerfoList);
		*/
	}
    
	
	//*******************************************
    public void printlnOut(String mess) {
    	outputTA.setEditable(true);
    	outputTA.append(mess +"\n");
    	outputTA.setEditable(false);
    	outputTA.setCaretPosition(outputTA.getDocument().getLength());
	}
	public void printOut(String mess) {
		outputTA.setEditable(true);
		outputTA.append(mess);
		outputTA.setEditable(false);
		outputTA.setCaretPosition(outputTA.getDocument().getLength());
    }
    
}
